import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
//import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.geom.Ellipse2D;
import java.util.Random;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;



public class Demo extends JPanel implements SoccerConstants,Runnable{

	private static Ellipse2D.Float east_player = new Ellipse2D.Float();
	private static Ellipse2D.Float west_player = new Ellipse2D.Float();
	private static Ellipse2D.Float fieldCircle = new Ellipse2D.Float();
	private static Ellipse2D players[]= new Ellipse2D[8];
	private static Ellipse2D.Float ball= new Ellipse2D.Float();
	private static Player coordinates[]= new Player[8];
	private static int MAX_X=1500;
	private static int MAX_Y=1000;
	private static int ball_x=730;
	private static int ball_y=400;
	private int	field[][]=new int[1500][1000];
	private static int	points = 7; 
	private EastTeamStrategy team_east;
	private WestTeamStrategy team_west;
	private static int	east_score = 0, west_score = 0;
	private int	cur = 0;
	static JFrame frame;
	 
	public Demo(){
	}
	
	 public static void main(String[] args) throws InterruptedException {
		   
		    Demo sd= new Demo(); 
			frame = new JFrame("Soccer  "+ "East Team:" +east_score+" West Team:"+west_score);
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		    frame.add(new Demo());
		    frame.setSize(1500, 1000);
		    frame.setResizable(false);
		    frame.setLocationRelativeTo(null);
		    frame.setVisible(true);
		    sd.soccerMain();
	 }
	 
	 public void soccerMain() throws InterruptedException {
			
			int k,backwards_cur_x=0, backwards_cur_y=0,player_y,player_x;
			int cur_y;
			int cur_x;
			int	point_over = 0;
			int	game_over = 0;
			int	count = 0, player_nearby = 0;
			int	overall_count = 0;
			int	local_field[]=new int[9];
			int	local_backwards_field[]=new int[9];
			int	local_ball_field[]=new int[9];
			int	ball_direction = N;
			int	backwards_ball_direction = N;
			int	player_move = N;
			int	kick_direction = -1;
			int	kick_steps = 0;
			double	temp_angle = 0;
			double	path = 0;
			int	last_ball_x = 0, last_ball_y = 0;

			
			
			while(game_over!=1){
				
				init();
				point_over = 0;
				count = 0;
				overall_count = 0;
				kick_direction = -1;
				kick_steps = 0;
				
				
				for(int i=0; i<MAX_X; i++)
				{
				for(int j=0; j<MAX_Y; j++)
					{
					field[i][j] = EMPTY;
					}
				}
				
				for(int i=0; i<MAX_X; i++)
				{
					for(int j=0; j<MAX_Y; j++)
					{
						if ((i==0)||(i==(MAX_X -1)))
						{
							field[i][j] = GOAL;
							
						}
						if ((j==0)||(j==(MAX_Y-1)))
						{
							field[i][j] = BOUNDARY;
							
						}
					}
				}
				
				while (point_over != 1)
				{
					cur_x= coordinates[cur].getPlayer_x();
					cur_y=coordinates[cur].getPlayer_y();
					
					/* * Note the local field around the player*/
					 
					k = 0;
					for (int j = 0; j < 3; j++)
						for (int i = 0; i < 3; i++)
						{
							local_field[k++] = 
									field[cur_x+i-1][cur_y+j-1];
						}
					
					 /** Note the local field around the ball*/
					 
					k = 0;
					for (int j = 0; j < 3; j++){
						for (int i = 0; i < 3; i++)
						{
							local_ball_field[k++] = 
									field[ball_x+i-1][ball_y+j-1];
						}
					}

					
					 /** Figure out heading to ball*/
					 
					if ((ball_x == cur_x) && (ball_y == cur_y))
						temp_angle = 0;
					else
						temp_angle = 
						Math.atan2((ball_x - cur_x), 
								(ball_y - cur_y));
					temp_angle += PI;
					temp_angle = 360.0*temp_angle/(2.0*PI);
					ball_direction = N;
					if (temp_angle > 22.5+0*45)
						ball_direction = NW;
					if (temp_angle > 22.5+1*45)
						ball_direction = W;
					if (temp_angle > 22.5+2*45)
						ball_direction = SW;
					if (temp_angle > 22.5+3*45)
						ball_direction = S;
					if (temp_angle > 22.5+4*45)
						ball_direction = SE;
					if (temp_angle > 22.5+5*45)
						ball_direction = E;
					if (temp_angle > 22.5+6*45)
						ball_direction = NE;
					if (temp_angle > 22.5+7*45)
						ball_direction = N;

					
					 /** Construct backwards sensing for western players.*/
					 
					for (int i = 0; i <=8; i++){
						local_backwards_field[i]=local_field[8-i];
						backwards_ball_direction = swap_heading(ball_direction);
						backwards_cur_x = (MAX_X - 1) - cur_x;
						backwards_cur_y = (MAX_Y - 1) - cur_y;
					}

					switch(cur)
					{
					case 0: 
						team_east=new EastTeamStrategy();
						player_move = 
								team_east.EAST_player1(local_field, ball_direction,
									cur_x, cur_y);
					break;
					case 1: 
						team_west=new WestTeamStrategy();
						player_move = 
							swap_heading(
									team_west.WEST_player1(local_backwards_field, 
											backwards_ball_direction,
											backwards_cur_x, backwards_cur_y));
					break;
					case 2: 
						team_east=new EastTeamStrategy();
						player_move = 
								team_east.EAST_player2(local_field, ball_direction,
									cur_x, cur_y);
					break;
					case 3: 
						team_west=new WestTeamStrategy();
						player_move = 
							swap_heading(
									team_west.WEST_player2(local_backwards_field, 
											backwards_ball_direction,
											backwards_cur_x, backwards_cur_y));
					break;
					case 4:
						team_east=new EastTeamStrategy();
						player_move = 
								team_east.EAST_player3(local_field, ball_direction,
									cur_x, cur_y);
					break;
					case 5: 
						team_west=new WestTeamStrategy();
						player_move = 
							swap_heading(
									team_west.WEST_player3(local_backwards_field, 
											backwards_ball_direction,
											backwards_cur_x, backwards_cur_y));
					break;
					case 6: 
						team_east=new EastTeamStrategy();
						player_move = 
								team_east.EAST_player4(local_field, ball_direction,
									cur_x, cur_y);
					break;
					case 7: 
						team_west=new WestTeamStrategy();
						player_move = 
							swap_heading(
									team_west.WEST_player4(local_backwards_field, 
											backwards_ball_direction,
											backwards_cur_x, backwards_cur_y));
					break;
					}

					
					 /** Check for move = PLAYER*/ 
					 
					if (player_move == PLAYER)
					{
						player_move = DO_NOTHING;
					}


					
					/* * Check for KICK.  If the player wants to kick
					 * set up the kick, then set player_move to be
					 * heading in the direction of the ball.*/
					 
					if (player_move == KICK)
					{
						for(int i = 0; i<=8; i++)
						{
							/*--- Where is the ball ?---*/
							if (local_field[i] == BALL)
							{
								kick_direction = i;
								kick_steps = KICK_DIST;
								player_move = i;
								break;
							}
						}
						if (player_move == KICK)
						{
							/*--- Ball was NOT nearby ---*/
							player_move = N;
						}
					}
					

					/*
					 * Make sure heading is legal.*/
					 
					if ((player_move < 0) || (player_move > 8))
					{
						player_move = DO_NOTHING;
					}
					
					field[cur_x][cur_y] = EMPTY;
					
					/* * If the cell we are going to is empty, or
					 * the ball is there and the next cell after that is
					 * empty, then . . .*/
					 
					if ((local_field[player_move] == EMPTY) ||
							((local_field[player_move] == BALL)&&
									((local_ball_field[player_move] == EMPTY)||
											(local_ball_field[player_move] == GOAL)))) 
					{
						switch(player_move)
						{
						case N:
								 player_y=coordinates[cur].getPlayer_y();
								 coordinates[cur].setPlayer_y(player_y--);
								 move_player(cur,coordinates[cur].getPlayer_x(),player_y--);
								 path++; 
								 break;
						
						case S: 
								player_y=coordinates[cur].getPlayer_y();
								 coordinates[cur].setPlayer_y(player_y++);
								move_player(cur,coordinates[cur].getPlayer_x(),player_y++);
								path++; 
								break;
						case E:
								player_x=coordinates[cur].getPlayer_x();
								 coordinates[cur].setPlayer_x(player_x++);
								move_player(cur,player_x++,coordinates[cur].getPlayer_y());
							    path++; 
							    break;
						case W: 
								player_x=coordinates[cur].getPlayer_x();
								 coordinates[cur].setPlayer_x(player_x--);
								move_player(cur,player_x--,coordinates[cur].getPlayer_y());
								path++; 
								break;
						case NE: 
								player_y=coordinates[cur].getPlayer_y();
								player_x=coordinates[cur].getPlayer_x();
								 coordinates[cur].setPlayer_y(player_y--);
								 coordinates[cur].setPlayer_x(player_x++);
								move_player(cur,player_x++,player_y--);
								path+=SQR2; 
								break;
						case NW:
								player_y=coordinates[cur].getPlayer_y();
								player_x=coordinates[cur].getPlayer_x();
								coordinates[cur].setPlayer_y(player_y--);
								 coordinates[cur].setPlayer_x(player_x--);
								move_player(cur,player_x--,player_y--);
								path+=SQR2; 
								break;
						case SE:
								player_y=coordinates[cur].getPlayer_y();
								player_x=coordinates[cur].getPlayer_x();
								coordinates[cur].setPlayer_y(player_y++);
								 coordinates[cur].setPlayer_x(player_x++);
								move_player(cur,player_x++,player_y++);
								path+=SQR2;
						case SW:
								player_y=coordinates[cur].getPlayer_y();
								player_x=coordinates[cur].getPlayer_x();
								coordinates[cur].setPlayer_y(player_y++);
								 coordinates[cur].setPlayer_x(player_x--);
								move_player(cur,player_x--,player_y++);
								path+=SQR2; 
						}
					}
					

					
					 /** Mark the field with the player's new position.
*/					 
					if ((cur % 2) == 0){
						field[coordinates[cur].getPlayer_x()][coordinates[cur].getPlayer_y()] = EAST_PLAYER;}
					else{
						field[coordinates[cur].getPlayer_x()][coordinates[cur].getPlayer_y()] = WEST_PLAYER;}

					
					 /** Now move the ball.*/
					 
					if ((local_field[player_move] == BALL)&&
							((local_ball_field[player_move] == EMPTY)||
									(local_ball_field[player_move] == GOAL)))
					{
						field[ball_x][ball_y] = EMPTY;
						switch(player_move)
						{
						case N: ball_y--; 
								break;
						case S: ball_y++; 
								break;
						case E: ball_x++; 
								break;
						case W:ball_x--; 
								break;
						case NE: ball_y--; ball_x++; 
								break;
						case NW: ball_y--; ball_x--; 
								break;
						case SE: ball_y++; ball_x++; 
								break;
						case SW:ball_y++; ball_x--; 
								break;
						}
					}
					
					/* * Place the ball on the field.
*/					 
					//field[ball_x][ball_y] = BALL;
					
					
				 	 /** Now handle the case of a KICK*/
				 	 
					if (kick_steps > 0)
					{
						/*--- Revise the local ball field ---*/
						k = 0;
						for (int j = 0; j < 3; j++)
							for (int i = 0; i < 3; i++)
							{
								local_ball_field[k++] = 
										field[ball_x+i-1][ball_y+j-1];
							}

						/*--- Erase old position ---
						field[ball_x][ball_y] = EMPTY;*/

						/*--- Propel the ball if the space is empty ---*/
						if ((local_ball_field[kick_direction] == EMPTY) ||
								(local_ball_field[kick_direction] == GOAL))
							switch(kick_direction)
							{
							case N: ball_y--;
									break;
							case S: ball_y++; 
									break;
							case E: ball_x++; 
									break;
							case W: ball_x--; 
									break;
							case NE: ball_y--; ball_x++; 
									break;
							case NW: ball_y--; ball_x--; 
									break;
							case SE: ball_y++; ball_x++;
									break;
							case SW:ball_y++; ball_x--;
									break;
							default: break;
							}
						else
						{
							kick_direction = -1;
							kick_steps = 0;
						}
						kick_steps--;
						field[ball_x][ball_y] = BALL;
					}
					
					
					 /** Mark the new locations of the ball and
					 * the player on the field.*/
					 
					move_ball(ball_x,ball_y);
					if ((cur % 2) == 0)
					{
						move_player(cur,coordinates[cur].getPlayer_x(),coordinates[cur].getPlayer_y());
						Thread.sleep(1);
					}
					else
					{
						move_player(cur,coordinates[cur].getPlayer_x(),coordinates[cur].getPlayer_y());
						Thread.sleep(1);
					}

					
					 /** Check for a score.*/
					 
					if (ball_x <= 0)
					{
						east_score++;
						point_over = 1;
					}
					if (ball_x >= (MAX_X-1))
					{
						west_score++;
						point_over = 1;
					}
					
					
					frame.setTitle("Soccer  "+ "East Team:" +east_score+" West Team:"+west_score); 
					 /** Check for a stalemate.*/
					 
					player_nearby = 0;
					for (int i = 0; i<=8; i++)
						{
						if ((local_ball_field[i] == WEST_PLAYER) ||
							(local_ball_field[i] == EAST_PLAYER))
							player_nearby = 1;	
						}
					if ((player_nearby==1) &&
						((last_ball_x == ball_x)&&(last_ball_y) == (ball_y)))
						count++;
					if (count > TIME_LIMIT)
						{
						nudge_ball();
						count = 0;
						}
					if ((last_ball_x != ball_x)||(last_ball_y != ball_y))
						count = 0;
					last_ball_x = ball_x;
					last_ball_y = ball_y;										

					
					 /** Go on to the next player.*/
					 
					cur++;
					if (cur == 8) 
					      	cur = 0;
					
					 /** Check for first to 7 wins.*/
					  
					if ((west_score == points) || (east_score == points)){
						game_over = 1;}
					
				}
			}
			
			if(east_score>west_score){
				JOptionPane.showMessageDialog(frame,"Team East wins");
			}
			else{
				JOptionPane.showMessageDialog(frame,"Team West wins");
			}
	 }
	 
	 /*Call for movement of player*/
	public void move_player(int player,int current_x,int current_y){
	
		 coordinates[player].setPlayer_x(current_x);
		 coordinates[player].setPlayer_y(current_y);
		 repaint();
		
	 }
	 
	 /*Call for movement of ball*/
	 public void move_ball(int current_x,int current_y){
			
		 ball_x=current_x;
		 ball_y=current_y;
		 repaint();
		
	 }
	 
	 public void render(int w, int h, Graphics2D g2) 
	 {
		 g2.setColor(Color.RED);
		 g2.fill(east_player);
		 
		 g2.setColor(Color.BLUE);
		 g2.fill(west_player);
		 
		 g2.setColor(Color.BLACK);
		 g2.draw(fieldCircle);
		 
		 g2.setColor(Color.YELLOW);
		 g2.fill(ball);
		 
	 }
	 
	 public void init(){
		 
		 /*Initial Positions of players*/
		 for(int i=0;i<=6;i=i+2){
			   
			   coordinates[i]= new Player();
			   coordinates[i].setPlayer_x(450);
			   coordinates[i].setPlayer_y(250+(100*(i/2)));
			   
			   coordinates[i+1]= new Player();
			   coordinates[i+1].setPlayer_x(1000);
			   coordinates[i+1].setPlayer_y(250+(100*(i/2)));
		   }
		 
		 move_ball(740,400);
		 
		 for(int i=0;i<=6;i=i+2){
			 move_player(i, coordinates[i].getPlayer_x(), coordinates[i].getPlayer_y());
		 }
		 
	 }
	 
	 public void paint(Graphics g) 
	    {
		    super.paintComponent(g);
		    Graphics2D g2 = (Graphics2D) g;
		   
		    	
			    g2.setColor(Color.GREEN.darker().darker());
			    g2.fillRect(0, 0, 1500, 1000);
			    
			    g2.setColor(Color.BLACK);
			    g2.drawLine(MAX_X/2, 0,MAX_X/2,MAX_Y);
			    
			    fieldCircle.setFrame(562,260,380,380);
			    render(380,380,g2);
			    
			    ball.setFrame(ball_x, ball_y, 30, 30);
			    render(30,30,g2);
			    
			    for(int i=0;i<=6;i=i+2){
			    	
			    	 east_player.setFrame(coordinates[i].getPlayer_x(), coordinates[i].getPlayer_y(), 40, 40);
			    	 players[i]=east_player;
					 render(40,40,g2);
			    
			    	 west_player.setFrame(coordinates[i+1].getPlayer_x(), coordinates[i+1].getPlayer_y(), 40, 40);
			    	 players[i+1]=west_player;
					 render(40,40,g2);
			    }
			    
					
			    this.move_ball(this.ball_x,this.ball_y);
			    this.move_player(this.cur,this.coordinates[this.cur].getPlayer_x(),this.coordinates[this.cur].getPlayer_y());
			
	  }

		int swap_heading(int heading)
		{
			switch(heading)
			{
			case NW: return(SE);
			case N: return(S);
			case NE: return(SW);
			case E: return(W);
			case SE: return(NW);
			case S: return(N);
			case SW: return(NE);
			case W: return(E); 
			case KICK: return(KICK);
			case DO_NOTHING: return(DO_NOTHING);
			default: return(DO_NOTHING); 
			}
		}
	 
	  public void actionPerformed(ActionEvent e) {
		  repaint();
	  }
	  
	  public void nudge_ball(){
		  
		  int i = 1;
		  int temp;
		  do
		  	{
			  	temp = ball_y + ((new Random().nextInt()/256) % i) - (i/2) ;
			  	if (temp<1) temp = 1;
			  	if (temp>22) temp = 22;
			  	i++;
			  	if (i > 40) i = 40;
		  	}
		  while ((field[ball_x][temp] != EMPTY)&&(field[ball_x][temp] != GOAL));
		  field[ball_x][ball_y] = EMPTY;
		  ball_y = temp;
		  field[ball_x][ball_y] = BALL;
		  move_ball(ball_x, ball_y);
		 
	  }

	@Override
	public void run() {
		// TODO Auto-generated method stub
	}
	 
	 
}
